<?php
//create naira currency and set as default
//copy module to required folder or install via PS
//install module
//configure module
//go to currency restrictions and select ce for naira and save

if (!defined('_CAN_LOAD_FILES_'))
	exit;
	
class cashenvoy extends PaymentModule {
	
    function __construct(){
        $this->name = 'cashenvoy';
        $this->tab = 'payments_gateways';
        $this->version = '1.0';
		$this->currencies = true;
		$this->currencies_mode = 'radio';
		$this->author = 'ESL';
        parent::__construct(); 
        $this->displayName = $this->l('CashEnvoy Payment Module');	
        $this->description = $this->l('Accept payments via eTranzact, Interswitch, Verve and Mastercard with CashEnvoy.');
		if (!sizeof(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency set for this module');
		if (!is_callable('curl_exec'))
			$this->warning = $this->l('cURL extension must be enabled on your server to use this module.');	
		$this->limited_countries[] = 'NGN';
		/* For 1.4.3 and less compatibility */
		$updateConfig = array('PS_OS_CHEQUE', 'PS_OS_PAYMENT', 'PS_OS_PREPARATION', 'PS_OS_SHIPPING', 'PS_OS_CANCELED', 'PS_OS_REFUND', 'PS_OS_ERROR', 'PS_OS_OUTOFSTOCK', 'PS_OS_BANKWIRE', 'PS_OS_PAYPAL', 'PS_OS_WS_PAYMENT');
		if (!Configuration::get('PS_OS_PAYMENT'))
			foreach ($updateConfig as $u)
				if (!Configuration::get($u) && defined('_'.$u.'_'))
					Configuration::updateValue($u, constant('_'.$u.'_'));
	}
	
	public function install(){
		if (!parent::install() OR 
		!$this->createLogCalls() OR
		!$this->registerHook('payment') OR
		!$this->registerHook('orderConfirmation') OR
		!Configuration::updateValue('CASHENVOY_MERCHANT_ID', '') OR
		!Configuration::updateValue('CASHENVOY_DISPLAY_NAME', $this->displayName) OR
		!Configuration::updateValue('CASHENVOY_MODE', 'sandbox') OR
		!Configuration::updateValue('CASHENVOY_MINIMUM_AMOUNT', '50')){
		return false; }
		return true;
	}

	public function createLogCalls(){
		$db = Db::getInstance(); 
		$query = "CREATE TABLE IF NOT EXISTS "._DB_PREFIX_."cashenvoy_outcall (
		  `ocid` int(11) NOT NULL AUTO_INCREMENT,
		  `cartid` int(11) NOT NULL,
		  `transref` varchar(20) NOT NULL,
		  `amount` decimal(15,4) NOT NULL,
		  `status` varchar(4) DEFAULT NULL,
		  `time` datetime NOT NULL,
		  PRIMARY KEY (`ocid`),
		  UNIQUE KEY `transref` (`transref`)
		) ENGINE=InnoDB";	
		$db->Execute($query);	
		$sql0 = "SELECT transref FROM `"._DB_PREFIX_."cart`";
		@$chk = $db->Execute($sql0);
		if(!@$chk){
			$sql2 = "ALTER IGNORE TABLE `"._DB_PREFIX_."cart` ADD transref VARCHAR( 20 ) NULL DEFAULT NULL, ADD UNIQUE (`transref`)";
			$db->Execute($sql2);			
		}
		return true;
	}	
	
	public function uninstall()	{
		return (parent::uninstall() AND
			Configuration::deleteByName('CASHENVOY_MERCHANT_ID') AND
			Configuration::deleteByName('CASHENVOY_MODE') AND
			Configuration::deleteByName('CASHENVOY_MINIMUM_AMOUNT'));
	}

	public function getContent(){
		if (Tools::isSubmit('submitCE')){
			$errors = array();
			if (($merchant_id = Tools::getValue('cashenvoy_merchant_id')) AND ctype_digit($merchant_id))
				Configuration::updateValue('CASHENVOY_MERCHANT_ID', $merchant_id);
			else
				$errors[] = '<div class="warning warn"><h3>'.$this->l('Merchant ID is incorrect').'</h3></div>';
			if ($mode = (Tools::getValue('cashenvoy_mode') == 'real' ? 'real' : 'sandbox'))
				Configuration::updateValue('CASHENVOY_MODE', $mode);
			if (($minimum_amount = Tools::getValue('cashenvoy_minimum_amount')) AND ctype_digit($minimum_amount) AND $minimum_amount>=50 )
				Configuration::updateValue('CASHENVOY_MINIMUM_AMOUNT', $minimum_amount);
			else
				$errors[] = '<div class="warning warn"><h3>'.$this->l('Minimum amount cannot be less than 50').'</h3></div>';
			if (!$errors){
				// Retro 1.4
				global $currentIndex;
				$curr_index = Tools::property_exists('AdminController', 'currentIndex') ?
					AdminController::$currentIndex : $currentIndex;
				Tools::redirectAdmin($curr_index.'&configure=cashenvoy&token='.Tools::safeOutput(Tools::getValue('token')).'&conf=4');
			}
			foreach ($errors as $error)
				echo $error;
		}
		$html = '<h2>'.$this->displayName.'</h2>
		<form action="'.Tools::safeOutput($_SERVER['REQUEST_URI']).'" method="post">
			<fieldset>
			<legend><img src="'.__PS_BASE_URI__.'modules/cashenvoy/logo.gif" />'.$this->l('Settings').'</legend>
			<p>
				<div class="warn">
					'.$this->l('This module works with the latest CashEnvoy Payment API').'
				</div>
			</p>
				<p>'.$this->l('Use the sandbox to test out the module. You cannot use the real mode until testing has been done by CashEnvoy.').'</p>
				<p>'.$this->l('').'</p>
				<label>
					'.$this->l('Mode').'
				</label>
				<div class="margin-form">
					<select name="cashenvoy_mode">
						<option value="real"'.(Configuration::get('CASHENVOY_MODE') == 'real' ? ' selected="selected"' : '').'>'.$this->l('Real').'&nbsp;&nbsp;</option>
						<option value="sandbox"'.(Configuration::get('CASHENVOY_MODE') == 'sandbox' ? ' selected="selected"' : '').'>'.$this->l('Sandbox').'&nbsp;&nbsp;</option>
					</select>
				</div>
				<label>
					'.$this->l('Currency').'
				</label>
				<div class="margin-form" style="margin-top:3px;font-size:12px;color:black">
				'.$this->getCurrency()->iso_code.'
				</div>
				<label>
					'.$this->l('Merchant ID').'
				</label>
				<div class="margin-form">
					<input type="text" name="cashenvoy_merchant_id" value="'.Tools::safeOutput(Tools::getValue('cashenvoy_merchant_id', Configuration::get('CASHENVOY_MERCHANT_ID'))).'" />
				</div>
				<label>
					'.$this->l('Minimum Transaction Amount').'
				</label>
				<div class="margin-form" >
					<input type="text" name="cashenvoy_minimum_amount" value="'.Tools::safeOutput(Tools::getValue('cashenvoy_minimum_amount', Configuration::get('CASHENVOY_MINIMUM_AMOUNT'))).'" />
				</div>
				<p>'.$this->l('').'</p>
				<div class="clear center"><input type="submit" name="submitCE" class="button" value="'.$this->l('   Save Settings  ').'" /></div>
			</fieldset>
		</form>
		<br /><br />
		<fieldset>
			<legend><img src="../img/admin/warning.gif" />'.$this->l('Information').'</legend>
			<p>- '.$this->l('The API callback URL is:').' 
				<b>'.Tools::getShopDomainSsl(true, true).__PS_BASE_URI__.'modules/cashenvoy/validation.php</b>. 
				Your cron job should call this URL once every 15 minutes.
			</p>
			<p>- '.$this->l('This module can only be used with Naira transactions.').'<p>
		</fieldset>';
		return $html;
	}	
	
	private function generateTXRef($id){
		$rx = mt_rand(10,99);
		$ref = $id.str_shuffle(date("ymdHis").$rx);
		return $ref;
	}
	
	public function requery($request){	
		if (Configuration::get('CASHENVOY_MODE')=='real'){
			$url = 'https://www.cashenvoy.com/webservice/?cmd=requery';
		} else {
			$url = 'https://www.cashenvoy.com/sandbox/?cmd=requery';
		} 
		$curl = curl_init(); 
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $request);	
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);			
		$res = curl_exec($curl);
		curl_close($curl);
		return $res;
	}	

	public function hookPayment($params){
		global $smarty; 
		if (!$this->active)	return;		
		$CashEnvoyParams = array();
		if (Configuration::get('CASHENVOY_MODE')=='real'){
			$CashEnvoyParams['ce_action'] = 'webservice';
		} else {
			$CashEnvoyParams['ce_action'] = 'sandbox';
		}
		$CashEnvoyParams['ce_merchantid'] = Configuration::get('CASHENVOY_MERCHANT_ID');		
		$CashEnvoyParams['ce_amount'] = number_format($params['cart']->getOrderTotal(true, 3), 2, '.', '');
		$CashEnvoyParams['ce_customerid'] = $params['cookie']->email;		
		$id_cart = (int)$params['cart']->id;
		$CashEnvoyParams['ce_transref'] = $this->generateTXRef($id_cart);	
		$memo = '';
		$products = $params['cart']->getProducts();
		foreach($products as $key=>$k){ 
			$memo .= $k['cart_quantity'].' - '.$k['name'].' - <b>Price</b> ('.number_format($k['price'],2).')<br/>';
		}
		$memo .= '<b>Cart Id: '.$id_cart.'</b><br/>';
		$memo = '-'; //Removing detailed memo for now.
		$CashEnvoyParams['ce_window'] = 'parent';
		$CashEnvoyParams['ce_data'] = 'none';
		$CashEnvoyParams['ce_memo'] = $memo;
		if (method_exists('Tools', 'getShopDomainSsl'))
			$url = 'http://'.Tools::getShopDomainSsl().__PS_BASE_URI__.'modules/'.$this->name.'/';
		else
			$url = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/'.$this->name.'/';
		$CashEnvoyParams['ce_notifyurl'] = $this->name;	
		$smarty->assign('p', $CashEnvoyParams);
		$smarty->assign('new_base_dir', $url);
		$smarty->assign('bText', $this->l('Pay with your CashEnvoy account, eTranzact, Interswitch, Verve or Mastercard'));
		if($CashEnvoyParams['ce_amount'] >= Configuration::get('CASHENVOY_MINIMUM_AMOUNT')){
			return $this->display(__FILE__, 'cashenvoy.tpl');
		}	
	}
	
	public function hookOrderConfirmation($params)	{
		global $smarty; 
		if ($params['objOrder']->module != $this->name) 
			return;
		$smarty->assign(array('status' => 'ok', 'id_order' => intval($params['objOrder']->id)));
		return $this->display(__FILE__, 'hookorderconfirmation.tpl'); 
	}
	
	public function failedTX($msg)	{
		if (!$this->active)	return;
		global $smarty; 
		$smarty->assign(array(
			'msg' => $msg
		));
		return $this->display(__FILE__, 'failedtx.tpl');
	}
}
?>